library MV_ALLODS;


uses
  Windows,
  KOL,
  data_BMPheader,
  imc,
  MV_utils;

//{$R *.res}

var Image: FormatItem;
    FrmtInfo: CurrentFormatInfo;
    ImComplex: TImageComplex;
    PI: PStream;

function MVPI: Byte; stdcall;
begin
  Result:= $10;
end;

function GetMVPlugInfo: PluginInfo; stdcall;
begin
  Result.Name := 'Allods Plug-in';
  Result.Author := 'Magic Team';
  Result.Version := '1.0.0 Beta';
  Result.Comment := 'Supports Allods Graphics (16A & 256)!';
  // Number of formats defined in Formats array (see below)
  Result.NumFormats := 2;
  Result.Formats[1].Extensions := '*.256';
  Result.Formats[1].Name := 'Allods Images (*.256)';
  Result.Formats[1].iType := IMAGE_TYPE;
  Result.Formats[1].sFlag := NO_SAVE;
  Result.Formats[2].Extensions := '*.16a';
  Result.Formats[2].Name := 'Allods Images (*.16A)';
  Result.Formats[2].iType := IMAGE_TYPE;
  Result.Formats[2].sFlag := NO_SAVE;
end;


function CanRead (fil: ShortString; StrongDetect: Boolean): Boolean; stdcall;
var ext: string;
begin

  // Put file extension uppercase form in ext var
  ext := ExtractFileExt(fil);
  if ext <> '' then
    ext := copy(ext,2,length(ext)-1);
  ext := UpperCase(ext);

  if (ext = '256')or(ext = '16A') then
    Result := True
  else
    Result := False;

end;

procedure CloseFile; stdcall;
begin
  // This is an example
  // Change it the way you need
  FrmtInfo.ID := '';
  FrmtInfo.Comment:='';
  if Assigned(ImComplex) then
   begin
    ImComplex.Clear;
    Free_And_Nil(ImComplex);
   end;
  if Assigned(PI) then
   Free_And_Nil(PI);
end;

function GetCurrentFormatInfo(): CurrentFormatInfo; stdcall;
begin
  Result:= FrmtInfo;
end;

function GetItem (idx: Integer; Full: Boolean; progress: ProgressCallback; Palette: Pointer): FormatItem; stdcall;
begin
   if Assigned(PI) then Free_And_Nil(PI);
   PI:=NewMemoryStream;
   ImComplex.Items[idx].Bitmap.SaveToStream(PI);
   Image.Name:=ImComplex.Items[idx].Name;
   Image.Handle:=PI.Memory;
   Image.Size:=PI.Size;
   Result:= Image;
end;

function ReadFile (fName: ShortString; progress: ProgressCallback; Palette: Pointer): Integer; stdcall;
var
  BMPPalette: TBMPPalette;
  FDat,FTemp,FMem: PStream;
  i,j,x,y,z,SavePosition: LongInt;
  TotalSprites,SS: Word;
  FreeBuffer,Buffer: array[1..1024]of byte;
  fHeight,fWidth,fLeft,fTop,fRight,fBottom,fDataSize,fMaxWidth,fMaxHeight: LongInt;
  Add,DByte,DByteL,DByteR,SL,SR: Byte;
  fOnlyName,fStr,Extention: string;

function Expand(DB: Byte; var DBL,DBR: Byte): Boolean;
var
  fB: Byte;
begin
  fB:=DB;
  DBL:=fB shr 6;
  DBR:=fB and $3F;
end;

begin
  BMPHeader._C1:=$00000436;
  BMPHeader._C2:=$00000028;
  BMPHeader._C3:=$0001;
  BMPHeader._C4:=$0008;
  BMPHeader._H2:=$00;
  BMPHeader._H3:=$00;
  ImComplex:=TImageComplex.Create;

  FDat:=NewReadFileStream (fName);
  fOnlyName:=ExtractFileNameWOExt(fName);
  Extention:=UpperCase(ExtractFileExt(FName));

  FDat.Seek(FDat.Size-4,spBegin);
  FDat.Read(TotalSprites,2);
  // 
  FDat.Seek(0,spBegin);
  for i:=0 to 255 do
  begin
    FDat.Read(BMPPalette[i].R,1);
    FDat.Read(BMPPalette[i].G,1);
    FDat.Read(BMPPalette[i].B,1);
    FDat.Read(BMPPalette[i].F,1);
  end;
  BMPPalette[0].R:=$FF;
  BMPPalette[0].G:=0;
  BMPPalette[0].B:=$FF;

  Move(BMPPalette[0],Palette^,1024);
  FrmtInfo.HavePalette:=True;
  
  SavePosition:=FDat.Position;
  //   
  fMaxWidth:=0;
  fMaxHeight:=0;
  for i:=1 to TotalSprites do
  begin
    FDat.Seek(SavePosition,spBegin);
    FDat.Read(fWidth,4);
    FDat.Read(fHeight,4);
    if fWidth>fMaxWidth then fMaxWidth:=fWidth;
    if fHeight>fMaxHeight then fMaxHeight:=fHeight;
    FDat.Read(fDataSize,4);
    SavePosition:=SavePosition+fDataSize+12;
  end;
  //     
  for i:=1 to TotalSprites do ImComplex.Add;
  // 
  if Extention='.16A' then
  begin
    FDat.Seek($400,spBegin);
    SavePosition:=FDat.Position;
    for i:=1 to TotalSprites do
    begin
      FDat.Seek(SavePosition,spBegin);
      FDat.Read(fWidth,4);
      FDat.Read(fHeight,4);
      FDat.Read(fDataSize,4);
      SavePosition:=SavePosition+fDataSize+12;
      //     
      FTemp:=NewMemoryStream; //   BMP
      FMem:=NewMemoryStream;  // 
      fLeft:=(fMaxWidth-fWidth) div 2;
      fRight:=fMaxWidth-fWidth-fLeft;
      fTop:=(fMaxHeight-fHeight) div 2;
      fBottom:=fMaxHeight-fHeight-fTop;
      //   
      BMPHeader.x:=fMaxWidth;
      BMPHeader.y:=fMaxHeight;
      BMPheader.DataSize1:=BMPHeader.x*BMPHeader.y;
      BMPheader.DataSize2:=BMPHeader.x*BMPHeader.y;
      BMPHeader.FullSize:=BMPHeader.DataSize1+$436;
      BMPHeader._H3:=BMPHeader.FullSize-$36;
      FTemp.Write(bmpID,2);
      FTemp.Write(BMPHeader,SizeOf(BMPHeader));
      FTemp.Write(BMPPalette,1024);
      Add:=Round(Int((4*(1-(Frac(fMaxWidth/4))))));
      if Add=4 then Add:=0;
      FillChar(Buffer,1024,$00);
      FillChar(FreeBuffer,1024,$00);
      //
      if fTop>0 then for z:=1 to fTop do FMem.Write(Buffer,fMaxWidth+Add);
      y:=0;
      repeat
        if fLeft>0 then fMem.Write(FreeBuffer,fLeft);
        x:=0;
        repeat
          FDat.Read(DByteL,1);
          FDat.Read(DByteR,1);
          case DByteR of
          $00:begin
                FDat.Read(Buffer,DByteL*2);
                for z:=1 to DByteL do
                begin
                //  SL:=Buffer[z*2] shr 4;
                  SR:=Buffer[z*2] and $0F;
                 // SS:=0;
                  SS:=SR;
                  SS:=SS shl 8;
                  SS:=SS+Buffer[z*2-1];
                  SS:=SS shr 1;
                  Buffer[z]:=SS;
                end;
                FMem.Write(Buffer,DByteL);
                x:=x+DByteL;
              end;
          $40:begin
                for z:=1 to DByteL do FMem.Write(FreeBuffer,fLeft+fRight+Add+fWidth);
                y:=y+DByteL;
                x:=fWidth;
              end;
          $80:begin
                FMem.Write(FreeBuffer,DByteL);
                x:=x+DByteL;
              end;
          end;
        until x=fWidth;
        if DByteR<>$40 then
        begin
          if fRight>0 then fMem.Write(FreeBuffer,fRight);
          if Add>0 then FMem.Write(FreeBuffer,Add);
          Inc(y);
        end;
      until y=fHeight;
      if fBottom>0 then for z:=1 to fBottom do FMem.Write(Buffer,fMaxWidth+Add);
      for y:=1 to fMaxHeight do
      begin
        FMem.Seek((fMaxHeight-y)*(fMaxWidth+Add),spBegin);
        Stream2Stream(FTemp,FMem,fMaxWidth+Add);
      end;
      FTemp.Seek(0,spBegin);
      ImComplex.Items[i-1].LoadImageFromStream(FTemp);
      ImComplex.Items[i-1].Name:=fOnlyName+Int2Str(i-1);
      FMem.Free;
      FTemp.Free;
      Progress(Round(Int(100*(i/TotalSprites))));
    end;
   FrmtInfo.ID:='16A';
   FrmtInfo.Comment:='Allods 16A Graphics';
  end else
  if Extention='.256' then
  begin
    FDat.Seek($400,spBegin);
    SavePosition:=FDat.Position;
    for i:=1 to TotalSprites do
    begin
      FDat.Seek(SavePosition,spBegin);
      FDat.Read(fWidth,4);
      FDat.Read(fHeight,4);
      FDat.Read(fDataSize,4);
      SavePosition:=SavePosition+fDataSize+12;
      //     
      FTemp:=NewMemoryStream; //   BMP
      FMem:=NewMemoryStream;  // 
      fLeft:=(fMaxWidth-fWidth) div 2;
      fRight:=fMaxWidth-fWidth-fLeft;
      fTop:=(fMaxHeight-fHeight) div 2;
      fBottom:=fMaxHeight-fHeight-fTop;
      //   
      BMPHeader.x:=fMaxWidth;
      BMPHeader.y:=fMaxHeight;
      BMPheader.DataSize1:=BMPHeader.x*BMPHeader.y;
      BMPheader.DataSize2:=BMPHeader.x*BMPHeader.y;
      BMPHeader.FullSize:=BMPHeader.DataSize1+$436;
      BMPHeader._H3:=BMPHeader.FullSize-$36;
      FTemp.Write(bmpID,2);
      FTemp.Write(BMPHeader,SizeOf(BMPHeader));
      FTemp.Write(BMPPalette,1024);
      Add:=Round(Int((4*(1-(Frac(fMaxWidth/4))))));
      if Add=4 then Add:=0;
      FillChar(Buffer,1024,$00);
      FillChar(FreeBuffer,1024,$00);
      if fTop>0 then for z:=1 to fTop do FMem.Write(Buffer,fMaxWidth+Add);
      y:=0;
      repeat
        x:=0;
        if fLeft>0 then fMem.Write(FreeBuffer,fLeft);
        repeat
          FDat.Read(DByte,1);
          Expand(DByte,DByteL,DByteR);
          case DByteL of
          $0:begin
              Stream2Stream(FMem,FDat,DByteR);
              x:=x+DByteR;
             end;
          $1:begin
               FMem.Write(Buffer,fWidth+fRight+Add);
               if DByteR>1 then for z:=1 to DByteR-1 do FMem.Write(Buffer,fMaxWidth+Add);
               Inc(y,DByteR);
               x:=fWidth;
             end;
          $2:begin
               FMem.Write(Buffer,DByteR);
               x:=x+DByteR;
             end;
          end;
        until x>=fWidth;
        if DByteL<>1 then if fRight>0 then fMem.Write(Buffer,fRight);
        if DByteL<>1 then if Add>0 then fMem.Write(Buffer,Add);
        if DByteL<>1 then Inc(y);
      until y>=fHeight;
      if fBottom>0 then for j:=1 to fBottom do fMem.Write(Buffer,fMaxWidth+Add);
      for y:=1 to fMaxHeight do
      begin
        FMem.Seek((fMaxHeight-y)*(fMaxWidth+Add),spBegin);
        Stream2Stream(FTemp,FMem,fMaxWidth+Add);
      end;
      FTemp.Seek(0,spBegin);
      ImComplex.Items[i-1].LoadImageFromStream(FTemp);
      ImComplex.Items[i-1].Name:=fOnlyName+Int2Str(i-1);
      FMem.Free;
      FTemp.Free;
      Progress(Round(Int(100*(i/TotalSprites))));
    end;
      FrmtInfo.ID:='256';
      FrmtInfo.Comment:='Allods 256 Images';
  end;
  FDat.Free;

  Image.iType:=IMAGE_TYPE;
  Result:=ImComplex.Count;
end;

procedure About (ParentHWND: Integer; KOLParent: Pointer); stdcall;
begin

MessageBoxA(ParentHWND, PChar('Allods Plug-in'+#10+
                          ' Copyright 2004 Magic Team'+#10+#10+

                          '--------------------'+#10+
                          'Decoding algorithm based on infos by:'+#10+
                          'M.Bestchetnov (www.extractor.ru)'
                        )
                        , 'About Allods Plug-in...', MB_OK);
end;

exports
  CloseFile,
  MVPI,
  GetCurrentFormatInfo,
  GetMVPlugInfo,
  GetItem,
  CanRead,
  About,
  ReadFile;

begin
end.
