unit MV_utils;

interface

type
   // Record to store current file format information
   CurrentFormatInfo = record
     ID : ShortString;
     Comment: ShortString;
     HavePalette: Boolean;
   end;
   // Record to store a support file format
   FormatInfo = record
     Extensions : ShortString;    // List of extensions ";" separated
                                  // ex: *.PAK;*.WAD;*.EXT
     Name : ShortString;          // Name of the file format displayed in
                                  // DUP5 open dialog.
                                  // If multiple names separate them with a pipe
                                  // ex: Quake (*.PAK)|Quake 2 (*.PAK)
     sName : ShortString;
     iType: byte;
     sFlag: byte;            // Save Flag

   end;
   // Record to store information about the driver
   PluginInfo = record
     Name : ShortString;          // Name of the driver (ex: Default Driver)
     Author : ShortString;        // Your name (or nickname)
     Version : ShortString;       // String representation of the version number
     Comment : ShortString;       // Any comment you want to add (like code
                                  // source from this guy, blah blah, etc..)
     NumFormats : Byte;           // Number of FormatInfo defined in Formats
                                  // array
     Formats : array[1..255] of FormatInfo;
   end;

   // Record that stores an entry information
   FormatItem = record
      Name: ShortString;     // Filename of entry
      Size: Cardinal;        // Size of entry in currently
    Handle: Pointer;        // Pointer (handle) to Entry
     iType: byte;            //  
   end;

   ProgressCallback = procedure (p: byte);
//   TLanguageCallback = function (lngid: ShortString): ShortString;


const
   //  
   IMAGE_TYPE   = $01;
   PALETTE_TYPE = $02;
   WAVE_TYPE    = $03;

   //
   NO_SAVE       = $00;
   SIMPLE_SAVE   = $01;
   ADVANCED_SAVE = $02;

implementation

end.
